'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldNumber = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');
var _Btn = require('../Btn');var _Btn2 = _interopRequireDefault(_Btn);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

// prettier-ignore
var INPUT_PROPS = [
'name', 'disabled', 'min', 'max', 'placeholder', 'autoFocus', 'tabIndex', 'readOnly'];


/**
                                                                                        * @class FormFieldNumber
                                                                                        * @augments {Component<{
                                                                                             [x:string]: any
                                                                                             className?: string
                                                                                             disabled?: boolean
                                                                                             error?: any
                                                                                             id?: string
                                                                                             label?
                                                                                             max?: string | number
                                                                                             min?: string | number
                                                                                             name?: string
                                                                                             readOnly?: boolean
                                                                                             size?: string | number
                                                                                             style?: Object
                                                                                             value?: number
                                                                                             onBlur?: Function
                                                                                             onChange?: Function
                                                                                             onFocus?: Function
                                                                                           }, any>}
                                                                                        */var
FormFieldNumber = function (_Component) {_inherits(FormFieldNumber, _Component);function FormFieldNumber() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldNumber);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldNumber.__proto__ || Object.getPrototypeOf(FormFieldNumber)).call.apply(_ref, [this].concat(args))), _this), _this.































    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = Number(props.value);
      _this.setState({
        val: val,
        id: props.id || props.name && 'ff-number-' + props.name });

    }, _this.

    clamp = function (val) {var _this$props =
      _this.props,min = _this$props.min,max = _this$props.max,decimals = _this$props.decimals;
      val = Number(val.toFixed(decimals));
      if (typeof min !== 'undefined' && val < min) {
        val = Number(min);
      }
      if (typeof max !== 'undefined' && val > max) {
        val = Number(max);
      }
      return val;
    }, _this.

    preciseSum = function (val1, val2) {
      var decimals = Math.max(
      0,
      Number((String(val1).split('.')[1] || '').length),
      Number((String(val2).split('.')[1] || '').length));

      decimals = Math.min(decimals, _this.props.decimals);
      return Number((val1 + val2).toFixed(decimals));
    }, _this.

    handleChange = function (ev, val) {
      var isValProvided = typeof val === 'number';var
      target = ev.target;
      if (isValProvided) {
        val = _this.clamp(val);
      } else {
        if (target.value === '') {
          window.requestAnimationFrame(function () {return target.value = '';});
          return;
        }
        val = Number(target.value.replace(/[^\d.-]/g, ''));
      }

      _this.setState({ val: val });
      _this.props.onChange(val);
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {var
      val = _this.state.val;
      var clamped = _this.clamp(val);
      if (clamped !== val) {
        _this.props.onChange(clamped);
      }
      _this.setState({ focused: false, val: clamped });
      _this.props.onBlur(ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldNumber, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _this2 = this;var _props =









      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,size = _props.size,step = _props.step,error = _props.error;var _state =
      this.state,id = _state.id,val = _state.val,focused = _state.focused;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';
      return (
        _react2.default.createElement('div', { className: 'FormField FormField--number ' + className, style: style },
          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control',
              type: 'number',
              pattern: '[\\d.-]*',
              style: { width: 'calc(' + size + 'ch + 2em)' },
              autoComplete: 'off',
              value: val },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            !disabled &&
            !readOnly &&
            _react2.default.createElement(_Btn2.default, {
              tagName: 'span',
              className: 'FormField-spin FormField-spin--plus',
              disabled: disabled,
              onClick: function onClick(ev) {return (
                  _this2.handleChange(ev, _this2.preciseSum(val, step)));} }),



            !disabled &&
            !readOnly &&
            _react2.default.createElement(_Btn2.default, {
              tagName: 'span',
              className: 'FormField-spin FormField-spin--minus',
              disabled: disabled,
              onClick: function onClick(ev) {return (
                  _this2.handleChange(ev, _this2.preciseSum(val, -step)));} }),



            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldNumber;}(_react.Component);FormFieldNumber.propTypes = { className: _propTypes2.default.string, decimals: _propTypes2.default.number, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, id: _propTypes2.default.string, label: _propTypes2.default.node, max: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), step: _propTypes2.default.number, style: _propTypes2.default.object, value: _propTypes2.default.number, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func };FormFieldNumber.defaultProps = { className: '', decimals: 0, size: 100, step: 1, value: 0, onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {} };exports.default =


(0, _HOC.withDebounce)((0, _HOC.withValidation)(FormFieldNumber));exports.
FormFieldNumber = FormFieldNumber;