'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldRange = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var INPUT_PROPS = ['name', 'disabled', 'min', 'max', 'step', 'tabIndex'];

/**
                                                                           * @class FormFieldRange
                                                                           * @augments {Component<{
                                                                                [x:string]: any
                                                                                className?: string
                                                                                disabled?: boolean
                                                                                error?: any
                                                                                id?: string
                                                                                label?
                                                                                max?: string | number
                                                                                min?: string | number
                                                                                name?: string
                                                                                readOnly?: boolean
                                                                                size?: string | number
                                                                                step?: string | number
                                                                                style?: Object
                                                                                value?: number
                                                                                onBlur?: Function
                                                                                onChange?: Function
                                                                                onFocus?: Function
                                                                              }, any>}
                                                                           */var
FormFieldRange = function (_Component) {_inherits(FormFieldRange, _Component);function FormFieldRange() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldRange);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldRange.__proto__ || Object.getPrototypeOf(FormFieldRange)).call.apply(_ref, [this].concat(args))), _this), _this.




























    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = Number(props.value);
      _this.setState({
        val: val,
        id: props.id || props.name && 'ff-range-' + props.name });

    }, _this.

    handleChange = function (ev) {var _this$props =
      _this.props,disabled = _this$props.disabled,readOnly = _this$props.readOnly;
      var val = Number(ev.target.value);
      if (disabled || readOnly) {
        return;
      }

      _this.setState({ val: val });
      _this.props.onChange(val);
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      _this.setState({ focused: false });
      _this.props.onBlur(ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldRange, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _props =








      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,error = _props.error,readOnly = _props.readOnly,size = _props.size;var _state =
      this.state,id = _state.id,val = _state.val,focused = _state.focused;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';

      return (
        _react2.default.createElement('div', { className: 'FormField FormField--range ' + className, style: style },
          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control',
              type: 'range',
              style: { width: 'calc(' + size + 'ch + 2em)' },
              value: val },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldRange;}(_react.Component);FormFieldRange.propTypes = { className: _propTypes2.default.string, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, id: _propTypes2.default.string, label: _propTypes2.default.node, max: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), step: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), style: _propTypes2.default.object, value: _propTypes2.default.number, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func };FormFieldRange.defaultProps = { className: '', size: 100, value: 0, onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {} };exports.default =


(0, _HOC.withDebounce)(
(0, _HOC.withValidation)(FormFieldRange, { immediate: true }));exports.

FormFieldRange = FormFieldRange;