'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldSelect = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _toConsumableArray(arr) {if (Array.isArray(arr)) {for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) {arr2[i] = arr[i];}return arr2;} else {return Array.from(arr);}}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var INPUT_PROPS = ['name', 'disabled', 'tabIndex', 'readOnly'];

/**
                                                                 * @class FormFieldSelect
                                                                 * @augments {Component<{
                                                                      [x:string]: any
                                                                      className?: string
                                                                      disabled?: boolean
                                                                      error?: any
                                                                      id?: string
                                                                      label?
                                                                      name?: string
                                                                      options: Array<{ label, value }>
                                                                      placeholder?: string
                                                                      readOnly?: boolean
                                                                      style?: Object
                                                                      value?: string
                                                                      onBlur?: Function
                                                                      onChange?: Function
                                                                      onFocus?: Function
                                                                      valueRenderer?: Function
                                                                    }, any>}
                                                                 */var
FormFieldSelect = function (_Component) {_inherits(FormFieldSelect, _Component);function FormFieldSelect() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldSelect);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldSelect.__proto__ || Object.getPrototypeOf(FormFieldSelect)).call.apply(_ref, [this].concat(args))), _this), _this.































    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = props.value;
      var opts = [{ label: props.placeholder, value: '' }].concat(_toConsumableArray(props.options));
      _this.setState({
        val: val,
        opts: opts,
        id: props.id || props.name && 'ff-select-' + props.name });

    }, _this.

    findOption = function (val) {
      var option = null;
      _this.state.opts.some(
      function (o) {return String(o.value) === String(val) ? (option = o, true) : false;});

      return option;
    }, _this.

    handleChange = function (ev) {var
      opts = _this.state.opts;
      var val = opts[ev.target.selectedIndex].value;
      _this.setState({ val: val });
      _this.props.onChange(val);
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      _this.setState({ focused: false });
      _this.props.onBlur(ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldSelect, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _props =








      this.props,className = _props.className,style = _props.style,label = _props.label,valueRenderer = _props.valueRenderer,disabled = _props.disabled,readOnly = _props.readOnly,error = _props.error;var _state =
      this.state,id = _state.id,opts = _state.opts,val = _state.val,focused = _state.focused;
      var selectedOpt = this.findOption(val) || {};
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';

      return (
        _react2.default.createElement('div', { className: 'FormField FormField--select ' + className, style: style },
          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('span', { className: 'FormField-value' },
              valueRenderer(selectedOpt.label)),

            _react2.default.createElement('select', _extends({
                id: id,
                className: 'FormField-control',
                value: selectedOpt.value },
              (0, _pick3.default)(this.props, INPUT_PROPS), {
                onBlur: this.handleBlur,
                onChange: this.handleChange,
                onFocus: this.handleFocus }),

              opts.map(function (o, i) {return (
                  _react2.default.createElement('option', { key: i, value: o.value },
                    o.label || o.value));})),



            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldSelect;}(_react.Component);FormFieldSelect.propTypes = { className: _propTypes2.default.string, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, id: _propTypes2.default.string, label: _propTypes2.default.node, name: _propTypes2.default.string, options: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired, placeholder: _propTypes2.default.string, readOnly: _propTypes2.default.bool, style: _propTypes2.default.object, touched: _propTypes2.default.bool, value: _propTypes2.default.string, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func, validation: _propTypes2.default.func, valueRenderer: _propTypes2.default.func };FormFieldSelect.defaultProps = { className: '', placeholder: '— Select —', size: '', value: '', onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {}, valueRenderer: function valueRenderer(v) {return v;} };exports.default =


(0, _HOC.withDebounce)(
(0, _HOC.withValidation)(FormFieldSelect, { immediate: true }));exports.

FormFieldSelect = FormFieldSelect;