'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldText = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

// prettier-ignore
var INPUT_PROPS = [
'name', 'disabled', 'placeholder', 'type', 'pattern', 'tabIndex', 'readOnly',
'autoComplete', 'autoCapitalize', 'autoCorrect', 'autoFocus', 'spellCheck'];


/**
                                                                              * @class FormFieldText
                                                                              * @augments {Component<{
                                                                                   [x:string]: any
                                                                                   className?: string
                                                                                   disabled?: boolean
                                                                                   error?: any
                                                                                   iconLeft?
                                                                                   iconRight?
                                                                                   id?: string
                                                                                   label?
                                                                                   name?: string
                                                                                   readOnly?: boolean
                                                                                   size?: string | number
                                                                                   style?: Object
                                                                                   value?: string
                                                                                   onBlur?: Function
                                                                                   onChange?: Function
                                                                                   onFocus?: Function
                                                                                 }, any>}
                                                                              */var
FormFieldText = function (_Component) {_inherits(FormFieldText, _Component);function FormFieldText() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldText);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldText.__proto__ || Object.getPrototypeOf(FormFieldText)).call.apply(_ref, [this].concat(args))), _this), _this.




























    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = props.value;
      _this.setState({
        val: val,
        id: props.id || props.name && 'ff-text-' + props.name });

    }, _this.

    handleChange = function (ev) {
      var val = ev.target.value;
      _this.setState({ val: val });
      _this.props.onChange(val);
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      _this.setState({ focused: false });
      _this.props.onBlur(ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldText, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _this2 = this;var _props =










      this.props,className = _props.className,style = _props.style,label = _props.label,disabled = _props.disabled,readOnly = _props.readOnly,size = _props.size,iconLeft = _props.iconLeft,iconRight = _props.iconRight,error = _props.error;var _state =
      this.state,id = _state.id,val = _state.val,focused = _state.focused;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += error ? ' isInvalid' : '';
      className += focused ? ' isFocused' : '';
      var controlCN =
      (iconLeft ? 'FormField-control--iconLeft ' : '') + (
      iconRight ? 'FormField-control--iconRight ' : '');
      return (
        _react2.default.createElement('div', { className: 'FormField FormField--text ' + className, style: style },
          typeof label !== 'undefined' &&
          _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
            label),


          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control ' + controlCN,
              style: { width: 'calc(' + size + 'ch + 2em)' },
              value: val },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: function onChange(ev) {return _this2.handleChange(ev);},
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            iconLeft && _react2.default.createElement('div', { className: 'FormField-iconLeft' }, iconLeft),
            iconRight && _react2.default.createElement('div', { className: 'FormField-iconRight' }, iconRight),
            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldText;}(_react.Component);FormFieldText.propTypes = { className: _propTypes2.default.string, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, iconLeft: _propTypes2.default.node, iconRight: _propTypes2.default.node, id: _propTypes2.default.string, label: _propTypes2.default.node, name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, size: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]), style: _propTypes2.default.object, value: _propTypes2.default.string, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func };FormFieldText.defaultProps = { className: '', size: 100, type: 'text', value: '', onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {} };exports.default =


(0, _HOC.withDebounce)((0, _HOC.withValidation)(FormFieldText));exports.
FormFieldText = FormFieldText;