'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.FormFieldTick = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _pick2 = require('lodash/pick');var _pick3 = _interopRequireDefault(_pick2);

var _HOC = require('../HOC');
var _Icon = require('../Icon');var _Icon2 = _interopRequireDefault(_Icon);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

var INPUT_PROPS = ['name', 'disabled', 'tabIndex', 'type'];

/**
                                                             * @class FormFieldTick
                                                             * @augments {Component<{
                                                                  [x:string]: any
                                                                  checked?: boolean
                                                                  className?: string
                                                                  disabled?: boolean
                                                                  error?: any
                                                                  id?: string
                                                                  label?
                                                                  name?: string
                                                                  readOnly?: boolean
                                                                  style?: any
                                                                  type?: 'radio' | 'checkbox'
                                                                  value?: string
                                                                  onBlur?: Function
                                                                  onChange?: Function
                                                                  onFocus?: Function
                                                                }, any>}
                                                             */var
FormFieldTick = function (_Component) {_inherits(FormFieldTick, _Component);function FormFieldTick() {var _ref;var _temp, _this, _ret;_classCallCheck(this, FormFieldTick);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormFieldTick.__proto__ || Object.getPrototypeOf(FormFieldTick)).call.apply(_ref, [this].concat(args))), _this), _this.


























    state = {
      focused: false }, _this.










    setPropsToState = function (props) {
      var val = props.value;
      _this.setState({
        id:
        props.id ||
        'ff-tick-' + props.name + '-' + String(val).replace(/[^\w]/g, ''),
        checked: props.checked });

    }, _this.

    handleChange = function (ev) {var _this$props =
      _this.props,type = _this$props.type,disabled = _this$props.disabled,readOnly = _this$props.readOnly;
      var checked =
      type !== 'radio' || !_this.state.checked ? !_this.state.checked : true;
      if (disabled || readOnly) {
        return;
      }
      _this.setState({ checked: checked });
      _this.props.onChange(checked);
    }, _this.

    handleFocus = function (ev) {
      _this.setState({ focused: true });
      _this.props.onFocus(ev);
    }, _this.

    handleBlur = function (ev) {
      _this.setState({ focused: false });
      _this.props.onBlur(ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(FormFieldTick, [{ key: 'componentWillMount', value: function componentWillMount() {this.setPropsToState(this.props);} }, { key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {this.setPropsToState(nextProps);} }, { key: 'render', value: function render()

    {var _props =









      this.props,className = _props.className,style = _props.style,label = _props.label,value = _props.value,type = _props.type,disabled = _props.disabled,readOnly = _props.readOnly,error = _props.error;var _state =
      this.state,id = _state.id,checked = _state.checked;
      className += disabled ? ' isDisabled' : '';
      className += readOnly ? ' isReadOnly' : '';
      className += checked ? ' isChecked' : '';
      className += error ? ' isInvalid' : '';
      var boxtype = type === 'radio' ? 'radiobox' : type;
      return (
        _react2.default.createElement('div', {
            className: 'FormField FormField--' + boxtype + ' ' + className,
            style: style },

          _react2.default.createElement('div', { className: 'FormField-field' },
            _react2.default.createElement('input', _extends({
              id: id,
              className: 'FormField-control',
              checked: checked },
            (0, _pick3.default)(this.props, INPUT_PROPS), {
              onChange: this.handleChange,
              onFocus: this.handleFocus,
              onBlur: this.handleBlur })),

            _react2.default.createElement('label', { className: 'FormField-label', htmlFor: id },
              _react2.default.createElement('i', { className: 'FormField-tick' },
                _react2.default.createElement(_Icon2.default, { glyph: boxtype + '-' + (checked ? 'marked' : 'blank') })),

              _react2.default.createElement('span', { className: 'FormField-value' }, label || value)),

            error && _react2.default.createElement('div', { className: 'FormField-error' }, error))));



    } }]);return FormFieldTick;}(_react.Component);FormFieldTick.propTypes = { checked: _propTypes2.default.bool, className: _propTypes2.default.string, disabled: _propTypes2.default.bool, error: _propTypes2.default.any, id: _propTypes2.default.string, label: _propTypes2.default.node, name: _propTypes2.default.string, readOnly: _propTypes2.default.bool, style: _propTypes2.default.object, type: _propTypes2.default.oneOf(['radio', 'checkbox']), value: _propTypes2.default.any, onBlur: _propTypes2.default.func, onChange: _propTypes2.default.func, onFocus: _propTypes2.default.func };FormFieldTick.defaultProps = { checked: false, className: '', type: 'radio', onBlur: function onBlur() {}, onChange: function onChange() {}, onFocus: function onFocus() {} };exports.default =


(0, _HOC.withDebounce)(
(0, _HOC.withValidation)(FormFieldTick, {
  valueProp: 'checked',
  immediate: true }),

{ valueProp: 'checked' });exports.

FormFieldTick = FormFieldTick;