'use strict';Object.defineProperty(exports, "__esModule", { value: true });exports.withDebounce = exports.Debounce = undefined;var _extends = Object.assign || function (target) {for (var i = 1; i < arguments.length; i++) {var source = arguments[i];for (var key in source) {if (Object.prototype.hasOwnProperty.call(source, key)) {target[key] = source[key];}}}return target;};var _createClass = function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};}();var _react = require('react');var _react2 = _interopRequireDefault(_react);
var _propTypes = require('prop-types');var _propTypes2 = _interopRequireDefault(_propTypes);
var _debounce2 = require('lodash/debounce');var _debounce3 = _interopRequireDefault(_debounce2);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _objectWithoutProperties(obj, keys) {var target = {};for (var i in obj) {if (keys.indexOf(i) >= 0) continue;if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;target[i] = obj[i];}return target;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _possibleConstructorReturn(self, call) {if (!self) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return call && (typeof call === "object" || typeof call === "function") ? call : self;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}

function getWrappedChange(onChange, debounce) {
  return debounce ? (0, _debounce3.default)(onChange, debounce) : onChange;
}

/**
   * @class Debounce
   * @augments {Component<{
        value?: any
        debounce?: number
        onChange: Function
        render?: Function
      }, any>}
   */var
Debounce = exports.Debounce = function (_Component) {_inherits(Debounce, _Component);function Debounce() {var _ref;var _temp, _this, _ret;_classCallCheck(this, Debounce);for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {args[_key] = arguments[_key];}return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Debounce.__proto__ || Object.getPrototypeOf(Debounce)).call.apply(_ref, [this].concat(args))), _this), _this.












    state = {
      value: _this.props.value }, _this.


    isChanging = false, _this.











    onChange = function (value) {
      _this.isChanging = false;
      _this.props.onChange(value);
    }, _this.

    wrappedChange = getWrappedChange(_this.onChange, _this.props.debounce), _this.

    handleChange = function (value) {
      _this.isChanging = true;
      _this.setState({ value: value });
      _this.wrappedChange(value);
    }, _temp), _possibleConstructorReturn(_this, _ret);}_createClass(Debounce, [{ key: 'componentWillReceiveProps', value: function componentWillReceiveProps(nextProps) {var _props = this.props,debounce = _props.debounce,value = _props.value;if (nextProps.debounce !== debounce) {this.wrappedChange = getWrappedChange(this.onChange, nextProps.debounce);}if (nextProps.value !== value && !this.isChanging) {this.setState({ value: nextProps.value });}} }, { key: 'render', value: function render()

    {var _props2 =
      this.props,children = _props2.children,render = _props2.render;var
      value = this.state.value;
      var fn = typeof children === 'function' ? children : render;
      return fn(value, this.handleChange);
    } }]);return Debounce;}(_react.Component);Debounce.propTypes = { value: _propTypes2.default.any, debounce: _propTypes2.default.number, onChange: _propTypes2.default.func, render: _propTypes2.default.func, children: _propTypes2.default.func };Debounce.defaultProps = { onChange: function onChange() {} };


var withDebounce = function withDebounce(MyComponent) {var _ref2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},_ref2$valueProp = _ref2.valueProp,valueProp = _ref2$valueProp === undefined ? 'value' : _ref2$valueProp;return (
    function WithDebounce(_ref3)




    {var _ref3$debounce = _ref3.debounce,debounce = _ref3$debounce === undefined ? 0 : _ref3$debounce,onChange = _ref3.onChange,value = _ref3[valueProp],props = _objectWithoutProperties(_ref3, ['debounce', 'onChange', valueProp]);
      return (
        _react2.default.createElement(Debounce, { debounce: debounce, value: value, onChange: onChange },
          function (val, handleChange) {var _hocProps;
            var hocProps = (_hocProps = {}, _defineProperty(_hocProps,
            valueProp, val), _defineProperty(_hocProps, 'onChange',
            handleChange), _hocProps);

            return _react2.default.createElement(MyComponent, _extends({}, props, hocProps));
          }));


    });};exports.withDebounce = withDebounce;